/* file_byte_stream.h
 *
 * (C) 2000-2001 empeg ltd, http://www.empeg.com
 *
 * This software is licensed under the GNU General Public Licence (see file
 * COPYING), unless you possess an alternative written licence from empeg ltd.
 *
 * $Header: /home/cvs/symo/empeg/file_byte_stream.h,v 1.1 2001/08/24 20:03:51 peter Exp $
 */

#ifndef FILE_BYTE_STREAM_H
#define FILE_BYTE_STREAM_H 1

#include "stream.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>

// TODO: Merge this with the stuff in util.
class ReadFileStream : public SeekableStream
{
    FILE *m_f;

public:
    ReadFileStream();
    virtual ~ReadFileStream();

    STATUS Open(const char *file);
    void Close();

// Stream
public:
    virtual STATUS Read(void *buffer, unsigned bytesToRead, unsigned *pBytesRead);
    virtual STATUS Write(const void *buffer, unsigned bytesToWrite, unsigned *pBytesWritten);

// SeekableStream
public:
    virtual STATUS Tell(unsigned *position);
    virtual STATUS SeekAbsolute(unsigned absolutePosition);
    virtual STATUS SeekRelative(signed int relativePosition);
    virtual STATUS Length(unsigned *length);
};
#endif
