/* mp3_frame_info.h
 *
 * (C) 2000 empeg ltd, http://www.empeg.com
 *
 * This software is licensed under the GNU General Public Licence (see file
 * COPYING), unless you possess an alternative written licence from empeg ltd.
 *
 * $Header: /home/cvs/symo/empeg/mp3_frame_info.h,v 1.2 2001/10/01 18:46:45 peter Exp $
 */

#ifndef INCLUDED_MP3FRAMEINFO_H_
#define INCLUDED_MP3FRAMEINFO_H_

#include "empeg_error.h"
#include "vbr_header.h"
#include <string>
#include <string.h>


class SeekableStream;
struct ExtractTagsObserver;

class FrameInfoExtract
{
    SeekableStream *m_stream;

    // TODO: Implement SeekableStreamCache
    unsigned char m_buffer[32768];
    int m_buffer_start;
    int m_buffer_length;

    unsigned m_seekPos;
    unsigned m_dataOffset;
    unsigned m_length;
    unsigned long m_shiftReg;

    struct mp3_header
    {
	int layer_code;
	int mpeg_version_code;
	int bitrate_code;
	int samplerate_code;
	int channelmode_code;
	int layer_number;
	int padded;
	int bitrate;
	int samplerate;
	int length;
    };

    // TODO: move these out of the class...
    mp3_header m_mp3Header;
    xing_vbr_header m_vbrHeader;
    unsigned int m_firstHeader;

public:
    explicit FrameInfoExtract(SeekableStream *stream)
	: m_stream(stream), m_buffer_start(0), m_buffer_length(0), m_seekPos(0),
	m_dataOffset(0), m_length(0), m_shiftReg(0), m_firstHeader(0)
    {
	memset(&m_mp3Header, 0, sizeof(mp3_header));
	memset(&m_vbrHeader, 0, sizeof(xing_vbr_header));
    }

    STATUS Extract(int dataOffset, ExtractTagsObserver *pObserver);

private:
    void Skip(int howfar);
    
    /** Returns a byte (0..255) from the stream, or -1 for error.
     *
     * @todo Return a status.
     */
    int GetByte();
    unsigned long GetWord();

    bool GetVBRHeader();
    bool ParseVBRHeader(ExtractTagsObserver *pObserver);
    int FigureVBRHeaderOffset(int h_id, int h_mode);
    void FigureAverageBitrate(int length_ms, char *buffer, int bufflen);

    STATUS ParseMP3Frames(ExtractTagsObserver *pObserver);
    bool GetMP3Sync(int distance);
    int GetMP3Header();
    int FigureMP3Bitrate(int mpeg_version_code, int layer_number, int bitrate_code);
    int FigureMP3Samplerate(int mpeg_version_code, int samplerate_code);
};

#endif /* INCLUDED_MP3FRAMEINFO_H_ */
